﻿<Project Sdk="Microsoft.NET.Sdk">

  <PropertyGroup>
    <TargetFramework>netcoreapp3.1</TargetFramework>
    <EnableDefaultCompileItems>false</EnableDefaultCompileItems>
    <IsPackable>false</IsPackable>
    <Configurations>Debug;Release;Analyze</Configurations>
  </PropertyGroup>

  <ItemGroup>
    <EmbeddedResource Remove="TestData\NewFolder\**" />
    <None Remove="TestData\NewFolder\**" />
  </ItemGroup>

  <ItemGroup>
    <None Remove="TestData\Templates\test\itemNameValidation.config.json" />
    <None Remove="TestData\Templates\test\projectNameValidation.config.json" />
    <None Remove="TestData\Templates\test\_catalog\backendframeworks.json" />
    <None Remove="TestData\Templates\test\_catalog\en-US.backendframeworks.json" />
    <None Remove="TestData\Templates\test\_catalog\es-ES.backendframeworks.json" />
    <None Remove="TestData\Templates\test\_catalog\frontendframeworks\en-US.TestFramework.md" />
    <None Remove="TestData\Templates\test\_catalog\frontendframeworks\es-ES.TestFramework.md" />
    <None Remove="TestData\Templates\test\_catalog\frontendframeworks\TestFramework.md" />
  </ItemGroup>

  <ItemGroup>
    <Content Include="TestData\Templates\test\Dependencies.FeatureTemplate.dp2\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Dependencies.FeatureTemplate.dp1\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Exclusions.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Exclusions.FeatureTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Requirements.FeatureTemplate.r2\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Requirements.FeatureTemplate.r1\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Requirements.FeatureTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Requirements.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\TestingTemplateVB\.template.config\description.md" />
    <Content Include="TestData\Templates\test\TestingTemplateVB\.template.config\en-US.description.md" />
    <Content Include="TestData\Templates\test\TestingTemplateVB\.template.config\en-US.template.json" />
    <Content Include="TestData\Templates\test\TestingTemplateVB\.template.config\es-ES.template.json" />
    <Content Include="TestData\Templates\test\TestingTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\TestingTemplate\.template.config\en-US.template.json" />
    <Content Include="TestData\Templates\test\TestingTemplate\.template.config\es-ES.template.json" />
    <Content Include="TestData\Templates\test\TestingTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplateVB\.template.config\description.md" />
    <Content Include="TestData\Templates\test\FeatureTemplateVB\.template.config\en-US.description.md" />
    <Content Include="TestData\Templates\test\CompositionTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\CompositionTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Dependencies.FeatureTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Dependencies.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplateVB\.template.config\en-US.template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplateVB\.template.config\es-ES.template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplate\.template.config\en-US.template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplate\.template.config\es-ES.template.json" />
    <Content Include="TestData\Templates\test\FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Hidden.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Naming.DefaultNameTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\Naming.DefaultNameTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\OutputToParent.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\ServiceTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\ServiceTemplate\.template.config\en-US.template.json" />
    <Content Include="TestData\Templates\test\ServiceTemplate\.template.config\es-ES.template.json" />
    <Content Include="TestData\Templates\test\ServiceTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\PageTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\PageTemplate\.template.config\en-US.template.json" />
    <Content Include="TestData\Templates\test\PageTemplate\.template.config\es-ES.template.json" />
    <Content Include="TestData\Templates\test\PageTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\ProjectTemplate_FrontAndBack\.template.config\icon.png" />
    <Content Include="TestData\Templates\test\ProjectTemplate_FrontAndBack\.template.config\Layout.json" />
    <Content Include="TestData\Templates\test\ProjectTemplate_FrontAndBack\.template.config\template.json" />
    <Content Include="TestData\Templates\test\ProjectTemplateVB\.template.config\icon.png" />
    <Content Include="TestData\Templates\test\ProjectTemplateVB\.template.config\Layout.json" />
    <Content Include="TestData\Templates\test\ProjectTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\ProjectTemplate\.template.config\icon.png" />
    <Content Include="TestData\Templates\test\ProjectTemplate\.template.config\Layout.json" />
    <Content Include="TestData\Templates\test\ProjectTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\RightClick.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\TelemetryName.FeatureTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\UnspecifiedTemplateVB\.template.config\template.json" />
    <Content Include="TestData\Templates\test\UnspecifiedTemplate\.template.config\template.json" />
    <Content Include="TestData\Templates\test\_catalog\backendframeworks.json" />
    <Content Include="TestData\Templates\test\_catalog\en-US.backendframeworks.json" />
    <Content Include="TestData\Templates\test\_catalog\es-ES.backendframeworks.json" />
    <Content Include="TestData\Templates\test\_catalog\frontendframeworks\en-US.TestFramework.md" />
    <Content Include="TestData\Templates\test\_catalog\frontendframeworks\es-ES.TestFramework.md" />
    <Content Include="TestData\Templates\test\_catalog\frontendframeworks\TestFramework.md" />
    <Content Include="TestData\TestProject\Test.csproj">
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </Content>
  </ItemGroup>

  <ItemGroup>
    <PackageReference Include="Microsoft.NET.Test.Sdk" Version="15.9.0" />
    <PackageReference Include="System.Configuration.ConfigurationManager" Version="4.7.0" />
    <PackageReference Include="xunit" Version="2.4.1" />
    <PackageReference Include="xunit.runner.console" Version="2.4.1">
      <PrivateAssets>all</PrivateAssets>
      <IncludeAssets>runtime; build; native; contentfiles; analyzers</IncludeAssets>
    </PackageReference>
    <PackageReference Include="xunit.runner.visualstudio" Version="2.4.1">
      <PrivateAssets>all</PrivateAssets>
      <IncludeAssets>runtime; build; native; contentfiles; analyzers</IncludeAssets>
    </PackageReference>

    <PackageReference Include="StyleCop.Analyzers" Version="1.1.118">
      <PrivateAssets>all</PrivateAssets>
      <IncludeAssets>runtime; build; native; contentfiles; analyzers</IncludeAssets>
    </PackageReference>
  </ItemGroup>

  <ItemGroup>
    <ProjectReference Include="..\..\src\CoreTemplateStudio\CoreTemplateStudio.Core\CoreTemplateStudio.Core.csproj" />
  </ItemGroup>

  <PropertyGroup>
    <CodeAnalysisRuleSet>..\..\WtsRulesTests.ruleset</CodeAnalysisRuleSet>
    <AssemblyName>Microsoft.Templates.Core.Test</AssemblyName>
    <RootNamespace>Microsoft.Templates.Core.Test</RootNamespace>
  </PropertyGroup>

  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|AnyCPU'">
    <TreatWarningsAsErrors>false</TreatWarningsAsErrors>
    <WarningsAsErrors />
  </PropertyGroup>

  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Analyze|AnyCPU'">
    <TreatWarningsAsErrors>true</TreatWarningsAsErrors>
    <WarningsAsErrors />
  </PropertyGroup>

  <ItemGroup>
    <None Include="Packaging\SampleConfig.json">
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
    <None Include="Config\Ok.config.valid.json">
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
    <None Include="Config\Partial.config.valid.json">
      <SubType>Designer</SubType>
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
    <None Include="Config\Error.config.no.valid.json">
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
  </ItemGroup>

  <ItemGroup>
    <Compile Include="..\..\GlobalSuppressions.cs">
      <Link>GlobalSuppressions.cs</Link>
    </Compile>
    <Compile Include="Composition\FakeTemplateInfo.cs" />
    <Compile Include="Config\ConfigurationTests.cs" />
    <Compile Include="Diagnostics\HealthTest.cs" />
    <Compile Include="Diagnostics\FileHealthWriterTest.cs" />
    <Compile Include="Diagnostics\TelemetryFixture.cs" />
    <Compile Include="Diagnostics\TelemetryServiceTest.cs" />
    <Compile Include="Diagnostics\TestHealthWriter.cs" />
    <Compile Include="Extensions\StringExtensions.cs" />
    <Compile Include="Gen\GenComposerTests.cs" />
    <Compile Include="Naming\ItemNameServiceTests.cs" />
    <Compile Include="Naming\ProjectNameServiceTests.cs" />
    <Compile Include="Naming\Validators\DefaultNamesValidatorTests.cs" />
    <Compile Include="Naming\Validators\EmptyNameValidatorTests.cs" />
    <Compile Include="Naming\Validators\ExistingNamesValidatorTests.cs" />
    <Compile Include="Naming\Validators\FileNameValidatorTests.cs" />
    <Compile Include="Naming\Validators\FolderNameValidatorTests.cs" />
    <Compile Include="Naming\Validators\RegExValidatorTests.cs" />
    <Compile Include="Naming\Validators\ReservedNamesValidatorTests.cs" />
    <Compile Include="PostActions\Catalog\AddJsonDictionaryItemPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\CodeStyleProviders\BaseCodeStyleProviderTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\CodeStyleProviders\CSharpStyleProviderTest.cs" />
    <Compile Include="Templates\CasingExtensionsTests.cs" />
    <Compile Include="Templates\TemplateRepositoryTests.cs" />
    <Compile Include="Localization\LocalizationTest.cs" />
    <Compile Include="Locations\TemplateSourceConfigTests.cs" />
    <Compile Include="Locations\UnitTestsTemplatesSource.cs" />
    <Compile Include="PostActions\Catalog\AddItemToContextPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\FakeCreationPath.cs" />
    <Compile Include="PostActions\Catalog\FakeTemplateDefinedPostAction.cs" />
    <Compile Include="PostActions\Catalog\Merge\MergeHandlerTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\MergeTest.cs" />
    <Compile Include="PostActions\Catalog\SortNamespaces\SortImportsTest.cs" />
    <Compile Include="PostActions\Catalog\SortNamespaces\SortUsingsTest.cs" />
    <Compile Include="Templates\ITemplateInfoExtensionsTest.cs" />
    <Compile Include="Naming\NamingTests.cs" />
    <Compile Include="Naming\FolderNameValidatorTests.cs" />
    <Compile Include="Composition\CompositionQueryTest.cs" />
    <Content Include="TestData\Templates\test\projectNameValidation.config.json" />
    <Content Include="TestData\Templates\test\itemNameValidation.config.json" />
    <Compile Include="TestFakes\TestContextProvider.cs" />
    <Compile Include="TestFakes\TestDigitalSignatureService.cs" />
    <Compile Include="TestFakes\TestShell.cs" />
    <Compile Include="TestFakes\TestCertificateService.cs" />
    <Compile Include="PostActions\Catalog\Merge\MergeResourceDictionaryPostactionTest.cs" />
    <Compile Include="PostActions\Catalog\AddNugetReferenceToContextPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\AddProjectReferenceToContextPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\AddSdkReferenceToContextPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\NewItemGeneration\GenerateMergeInfoPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\MergePostactionTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\SearchAndReplacePostActionTest.cs" />
    <Compile Include="PostActions\Catalog\NewItemGeneration\CreateSummaryPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\NewItemGeneration\CopyFilesToProjectPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\Merge\NewItemGeneration\GetMergeFilesFromProjectPostActionTest.cs" />
    <Compile Include="PostActions\Catalog\GenerateTestCertificatePostActionTest.cs" />
    <Compile Include="Packaging\TemplatePackageTests.cs" />
    <Compile Include="Locations\RemoteTemplateSourceTests.cs" />


    <Content Include="..\..\TestCert.pfx">
      <Link>Packaging\TestCert.pfx</Link>
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </Content>
    <Content Include="Packaging\SampleContent.txt">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </Content>

    <None Include="TestData\Merge\Source_expectedWithOptionalContextLines.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\SourceWithOptionalContextLines.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\GenerationSummary_expected.md">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Steps to include new item generation_expected.md">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source_gpostaction.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source_expectedmergeinfo.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\SearchReplace\Source.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\SearchReplace\Source_expected.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\SearchReplace\NoSource_searchreplace.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\SearchReplace\Source_searchreplace.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\NoSource_postaction.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source_fail_postaction.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source_fail.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>

    <None Include="TestData\TestJson\**\*.*">
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>

    <AdditionalFiles Include="..\..\StyleCop.json">
      <Link>StyleCop.json</Link>
    </AdditionalFiles>
    <None Include="Packaging\MsSigned\Templates.mstx">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source_expected.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source_postaction.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Merge\Source.cs">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
    <Compile Include="Templates\TemplateLicenseEqualityComparerTest.cs" />
    <Compile Include="Templates\TemplatesFixture.cs" />
    <None Include="Packaging\SampleConfig.json">
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
    <Content Include="TestData\Templates\test\_catalog\en-US.frontendframeworks.json" />
    <Content Include="TestData\Templates\test\_catalog\es-ES.frontendframeworks.json" />
    <Content Include="TestData\Templates\test\_catalog\frontendframeworks.json" />
    <Content Include="TestData\Templates\test\_catalog\backendframeworks\en-US.TestFramework.md" />
    <Content Include="TestData\Templates\test\_catalog\backendframeworks\es-ES.TestFramework.md" />
    <Content Include="TestData\Templates\test\_catalog\backendframeworks\TestFramework.md" />
    <Content Include="TestData\Templates\test\_catalog\en-US.projectTypes.json" />
    <Content Include="TestData\Templates\test\_catalog\es-ES.projectTypes.json" />
    <Content Include="TestData\Templates\test\_catalog\projectTypes.json" />
    <Content Include="TestData\Templates\test\_catalog\projectTypes\en-US.TestProjectType.md" />
    <Content Include="TestData\Templates\test\_catalog\projectTypes\es-ES.TestProjectType.md" />
    <Content Include="TestData\Templates\test\_catalog\projectTypes\TestProjectType.md" />
  </ItemGroup>

  <ItemGroup>
    <None Include="TestData\Merge\Style.xaml">
      <Generator>MSBuild:UpdateDesignTimeXaml</Generator>
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
  </ItemGroup>
  <ItemGroup>
    <None Include="TestData\Merge\Style_postaction.xaml">
      <Generator>MSBuild:UpdateDesignTimeXaml</Generator>
      <SubType>Designer</SubType>
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
  </ItemGroup>
  <ItemGroup>
    <None Include="TestData\Merge\Style_expected.xaml">
      <Generator>MSBuild:UpdateDesignTimeXaml</Generator>
      <SubType>Designer</SubType>
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
  </ItemGroup>
  <ItemGroup>
    <None Include="TestData\Merge\Style_fail_postaction.xaml">
      <Generator>MSBuild:UpdateDesignTimeXaml</Generator>
      <SubType>Designer</SubType>
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
    </None>
    <None Include="TestData\Templates\test\TestingTemplateVB\.template.config\es-ES.description.md" />
    <None Include="TestData\Templates\test\TestingTemplate\.template.config\description.md" />
    <None Include="TestData\Templates\test\TestingTemplate\.template.config\en-US.description.md" />
    <None Include="TestData\Templates\test\TestingTemplate\.template.config\es-ES.description.md" />
    <None Include="TestData\Templates\test\FeatureTemplateVB\.template.config\es-ES.description.md" />
    <None Include="TestData\Templates\test\FeatureTemplate\.template.config\description.md" />
    <None Include="TestData\Templates\test\FeatureTemplate\.template.config\en-US.description.md" />
    <None Include="TestData\Templates\test\FeatureTemplate\.template.config\es-ES.description.md" />
    <None Include="TestData\Templates\test\ServiceTemplate\.template.config\description.md" />
    <None Include="TestData\Templates\test\ServiceTemplate\.template.config\en-US.description.md" />
    <None Include="TestData\Templates\test\ServiceTemplate\.template.config\es-ES.description.md" />
    <None Include="TestData\Templates\test\PageTemplate\.template.config\description.md" />
    <None Include="TestData\Templates\test\PageTemplate\.template.config\en-US.description.md" />
    <None Include="TestData\Templates\test\PageTemplate\.template.config\es-ES.description.md" />
    <None Include="TestData\Templates\test\ProjectTemplate_FrontAndBack\.template.config\description.md" />
    <None Include="TestData\Templates\test\ProjectTemplateVB\.template.config\description.md" />
    <None Include="TestData\Templates\test\ProjectTemplate\.template.config\description.md" />
  </ItemGroup>
  <ItemGroup>
    <None Update="xunit.runner.json">
      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
    </None>
  </ItemGroup>
  <ItemGroup>
    <None Include="TestData\Merge\Style_fail.xaml">
      <Generator>MSBuild:UpdateDesignTimeXaml</Generator>
      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
      <SubType>Designer</SubType>
    </None>
  </ItemGroup>
</Project>
